<?php
/*------------------------------------------------------------------------

# com_joko - K2 Tools

# ------------------------------------------------------------------------

# author    Jiliko.net

# copyright Copyright (C) 2010 Jiliko.net. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.jiliko.net

# Technical Support:  Forum - http://www.jiliko.net/forum

-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

$mainframe = &JFactory::getApplication();

$lang = &JFactory::getLanguage();
$lang->load('com_k2templates');

$db = & JFactory::getDBO();
$status = new JObject();
$status->modules = array();
$status->plugins = array();
$status->k2Elements = array();

$src = $this->parent->getPath('source');

//Modules installation
$modules = &$this->manifest->getElementByPath('modules');
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {
	foreach ($modules->children() as $module) {
		$mname = $module->attributes('module');
		$client = $module->attributes('client');
		if(is_null($client)) $client = 'site';
		($client=='administrator')? $path=$src.DS.'administrator'.DS.'modules'.DS.$mname: $path = $src.DS.'modules'.DS.$mname;
		$installer = new JInstaller;
		$result = $installer->install($path);
		$status->modules[] = array('name'=>$mname,'client'=>$client, 'result'=>$result);
	}
}
//End modules installation

//Plugins installation
$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin) {
		$pname = $plugin->attributes('plugin');
		$pgroup = $plugin->attributes('group');
		$path = $src.DS.'plugins'.DS.$pgroup;
		$installer = new JInstaller;
		$result = $installer->install($path);
		$status->plugins[] = array('name'=>$pname,'group'=>$pgroup, 'result'=>$result);

		$query = "UPDATE #__plugins SET published=1 WHERE element=".$db->Quote($pname)." AND folder=".$db->Quote($pgroup);
		$db->setQuery($query);
		$db->query();
	}
}
//End plugins installation

//K2 Installation
//Copying new files to K2 installation directory. NOT A HACK, JUST NEW FILES
$k2Elements = &$this->manifest->getElementByPath('k2');
if (is_a($k2Elements, 'JSimpleXMLElement') && count($k2Elements->children())) {
	$srcK2Admin = $src.DS.'k2'.DS.'admin'.DS;
	$dstK2Admin = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS;
	
	$srcK2Site = $src.DS.'k2'.DS.'site'.DS;
	$dstK2Site = JPATH_SITE.DS.'components'.DS.'com_k2'.DS;

	foreach ($k2Elements->children() as $k2Element) {
		$srcType =  $k2Element->attributes('type');
		$k2Dest = $k2Element->attributes('dest');
		
		if ($k2Dest == 'admin') {
			$srcK2 = $srcK2Admin;
			$dstK2 = $dstK2Admin;
		} else {
			$srcK2 = $srcK2Site;
			$dstK2 = $dstK2Site;
		}

		//Forcing the system separator
		$k2ElementName = str_replace(array('/','\\'),DS,$k2Element->data());
		
		if ($srcType == 'folder') {
			if(JFolder::exists($dstK2.$k2ElementName))
				JFolder::delete($dstK2.$k2ElementName);
				
			$result = JFolder::copy($srcK2.$k2ElementName,$dstK2.$k2ElementName);
		}
		else {
			if(JFile::exists($dstK2.$k2ElementName))
				JFile::delete($dstK2.$k2ElementName);
				
			$result = JFile::copy($srcK2.$k2ElementName,$dstK2.$k2ElementName);
		}
		$status->k2Elements[] = array('name'=>'['.JText::_($srcType).'] '.$k2ElementName,'client'=>$k2Dest, 'result'=>$result);
	}
}
//End K2 installation

?>

<?php $rows = 0;?>
<h2><?php echo JText::_('Joko Installation Status'); ?></h2>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="2"><?php echo JText::_('Extension'); ?></th>
			<th width="30%"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo JText::_('Joko'); ?></td>
			<td><strong><?php echo JText::_('Installed'); ?></strong></td>
		</tr>
		<?php if (count($status->k2Elements)) : ?>
		<tr>
			<th><?php echo JText::_('K2 Element'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->k2Elements as $k2Element) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $k2Element['name']; ?></td>
			<td class="key"><?php echo ucfirst($k2Element['client']); ?></td>
			<td><strong><?php echo ($k2Element['result'] == true) ? JText::_('Copied') : $result; ?></strong></td>
		</tr>
		<?php endforeach;?>
		<?php endif;?>
		<?php if (count($status->modules)) : ?>
		<tr>
			<th><?php echo JText::_('Module'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td><strong><?php echo ($module['result'])?JText::_('Installed'):JText::_('Not installed'); ?></strong></td>
		</tr>
		<?php endforeach;?>
		<?php endif;?>
		<?php if (count($status->plugins)) : ?>
		<tr>
			<th><?php echo JText::_('Plugin'); ?></th>
			<th><?php echo JText::_('Group'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td><strong><?php echo ($plugin['result'])?JText::_('Installed'):JText::_('Not installed'); ?></strong></td>
		</tr>
		<?php endforeach; ?>
		<?php endif; ?>
	</tbody>
</table>
