<?php

/*------------------------------------------------------------------------

# com_k2templates - K2 Templates administration

# ------------------------------------------------------------------------

# author    Jiliko.net

# copyright Copyright (C) 2010 Jiliko.net. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.jiliko.net

# Technical Support:  Forum - http://www.jiliko.net/forum

-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

$lang = &JFactory::getLanguage();
$lang->load('com_k2templates');

$status = new JObject();
$status->modules = array ();
$status->plugins = array ();
$status->k2Elements = array();

$modules = & $this->manifest->getElementByPath('modules');
$plugins = & $this->manifest->getElementByPath('plugins');
$k2Elements = &$this->manifest->getElementByPath('k2');

if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

	foreach ($modules->children() as $module) {

		$mname = $module->attributes('module');
		$db = & JFactory::getDBO();
		$query = "SELECT `id` FROM `#__modules` WHERE module = ".$db->Quote($mname)."";
		$db->setQuery($query);
		$modules = $db->loadResultArray();
		if (count($modules)) {
			foreach ($modules as $module) {
				$installer = new JInstaller;
				$result = $installer->uninstall('module', $module, 0);
			}
		}
		$status->modules[] = array ('name'=>$mname, 'client'=>'Site', 'result'=>$result);
	}
}


if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin) {

		$pname = $plugin->attributes('plugin');
		$pgroup = $plugin->attributes('group');
		$db = & JFactory::getDBO();
		$query = 'SELECT `id` FROM #__plugins WHERE element = '.$db->Quote($pname).' AND folder = '.$db->Quote($pgroup);
		$db->setQuery($query);
		$plugins = $db->loadResultArray();
		if (count($plugins)) {
			foreach ($plugins as $plugin) {
				$installer = new JInstaller;
				$result = $installer->uninstall('plugin', $plugin, 0);
			}
		}
		$status->plugins[] = array ('name'=>$pname, 'group'=>$pgroup, 'result'=>$result);
	}
}

//K2 UnInstallation
if (is_a($k2Elements, 'JSimpleXMLElement') && count($k2Elements->children())) {

	$srcK2Admin = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS;
	$srcK2Site = JPATH_SITE.DS.'components'.DS.'com_k2'.DS;	

	foreach ($k2Elements->children() as $k2Element) {
		$srcType =  $k2Element->attributes('type');
		$k2Dest = $k2Element->attributes('dest');
		
		if ($k2Dest == 'admin') {
			$srcK2 = $srcK2Admin;
		} else {
			$srcK2 = $srcK2Site;
		}

		//Forcing the system separator
		$k2ElementName = str_replace(array('/','\\'),DS,$k2Element->data());
		
		if ($srcType == 'folder') {
			if(JFolder::exists($srcK2.$k2ElementName))
				$result = JFolder::delete($srcK2.$k2ElementName);
			else $result = JText::_('Folder doesn\'t exist');
			
		}
		else {
			if(JFile::exists($srcK2.$k2ElementName))
				$result = JFile::delete($srcK2.$k2ElementName);
			else $result = JText::_('File doesn\'t exist');
		}
			
		$status->k2Elements[] = array('name'=>'['.JText::_($srcType).'] '.$k2ElementName,'client'=>$k2Dest, 'result'=>$result);
	}
}
	
//End K2 installation

?>
<?php $rows = 0;?>
<h2><?php echo JText::_('K2 Templates Removal Status'); ?></h2>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="2"><?php echo JText::_('Extension'); ?></th>
			<th width="30%"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo JText::_('K2 Templates component'); ?></td>
			<td><strong><?php echo JText::_('Removed'); ?></strong></td>
		</tr>
		<?php if (count($status->k2Elements)) : ?>
		<tr>
			<th><?php echo JText::_('K2 Element'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->k2Elements as $k2Element) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $k2Element['name']; ?></td>
			<td class="key"><?php echo ucfirst($k2Element['client']); ?></td>
			<td><strong><?php echo ($k2Element['result'] == true) ? JText::_('Deleted') : $result; ?></strong></td>
		</tr>
		<?php endforeach;?>
		<?php endif;?>
		<?php if (count($status->modules)) : ?>
		<tr>
			<th><?php echo JText::_('Module'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td><strong><?php echo ($module['result'])?JText::_('Removed'):JText::_('Not removed'); ?></strong></td>
		</tr>
		<?php endforeach;?>
		<?php endif; ?>

		<?php if (count($status->plugins)) : ?>
		<tr>
			<th><?php echo JText::_('Plugin'); ?></th>
			<th><?php echo JText::_('Group'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td><strong><?php echo ($plugin['result'])?JText::_('Removed'):JText::_('Not removed'); ?></strong></td>
		</tr>
		<?php endforeach; ?>
		<?php endif; ?>
	</tbody>
</table>
